define("ZSYWEB.BasicPlug", ['ZSYWEB.Klass', 'ZSYWEB.Util', 'ZSYWEB.Event'], function (){
	var Klass = ZSYWEB.Klass;
	var util = ZSYWEB.Util;
	var Event = ZSYWEB.Event;
	var BasicPlug = Klass.extendClass({
		constructor : function() {
			this.propr = null;
		},
		setPropr : function( obj ) {
			this.propr = obj;
			// this.init();
		},
		initState : function() {
			return {};
		},
		getState : function() {
			this.state = this.initState();
		},
		setState : function( obj ) {
			var state = this.state;
			var t = $.extend(true,{}, state, obj);
			this.state = t;
			this.renderDom();
		},
		resolveTemp : function() {
			var state = this.state;
			var template = this.template;
			for( var k in state ) {
				var temp = new RegExp("\\{{this.state." + k + "}}", "g");
				if( template != null ) {
					template = template.replace(temp, state[k]);
				}
			}
			return template;
		},
		resolevePropr : function() {
			var propr = this.propr;
			var template = this.template;
			if( propr == null ) {
				return;
			}
			for( var k in propr ) {
				var temp = new RegExp("\\{{" + k + "}}", "g");
				if( template != null ) {
					template = template.replace(temp, propr[k]);
				}
			}
			this.template = template;
		},
		init : function( attrs, dom ) {
			this.$container = dom;
			this.$orginHtm = dom.html();
			this.setPropr(attrs);
			this.getState();
			this.resolevePropr();
			// this.setState();
			this.resolveTemp();
			// this.renderDom();
		},
		renderDom : function(dom) {
			var attrs = this.propr;
			var dom = $(attrs['plugType']+"[plugid='"+attrs['plugid']+"']");
			var temp = this.resolveTemp();
			var htm = this.$orginHtm;
			dom.html(temp);
			var tempDom = util.findLastChild(dom);
			if( htm.trim() != '' ) {
				var lastNode = util.findLastChild(dom);
				lastNode.html(htm);
			}
			tempDom.attrs(attrs);
			for( var key in attrs ) {
				if( key.split('binder-').length > 1 ) {
					dom.removeAttr(key);
				}
			}
			tempDom.removeAttr("plugid");
			tempDom.removeAttr("plugType");
			this.resolveEvent(dom);
			this.render( dom, attrs );
		},
		resolveEvent : function( dom ) {
			var _this = this;
			var ckevent = dom.find("[on-click]");
			for( var i = 0; i < ckevent.length; i++ ) {
				var _d = ckevent[i];
				Event.bind($(_d), "", "click", function( dom, evt ){
					var fn = dom.attr('on-click').split('this.')[1];
					_this[fn](dom, evt);
					evt.evt.stopPropagation();
				});
			}
		},
		render : function() {}
	});
	NameSpace.Register("ZSYWEB.BasicPlug", BasicPlug);
    return BasicPlug;
});
