define("ZSYWEB.Comm",
	[
		"juicer",
		"ZSYWEB.Event",
		"ZSYWEB.Widget.Alert",
		'ZSYWEB.Util',
		'ZSYWEB.Widget.Popup',
		"ZSYWEB.Services"
	], function(require){
	var $core = ZSYWEB.Core
		, $evt = ZSYWEB.Event
		, dialog = ZSYWEB.Widget.Alert
		, page = 1
		, lastData = true
		, listLoadingObj
		;

	// 发布订阅
	var publishEvents = (function(){
		var listen,log,obj, one, remove, trigger, __this;
		obj = {};
		__this = this;
		listen = function( key, eventfn ) {  // 订阅
			var stack, _ref;
			stack = ( _ref = obj[key] ) != null ? _ref : obj[ key ] = [];
			return stack.push( eventfn );
		};
		one = function( key, eventfn ) {
			remove( key );
			return listen( key, eventfn );
		};
		remove = function( key ) {  // 解除
			var _ref;
			return ( _ref = obj[key] ) != null ? _ref.length = 0 : void 0;
		};
		trigger = function() {   // 发布
			var fn, stack, _i, _len, _ref, key;
			key = Array.prototype.shift.call( arguments );
			stack = ( _ref = obj[ key ] ) != null ? _ref : obj[ key ] = [];
			for ( _i = 0, _len = stack.length; _i < _len; _i++ ) {
				fn = stack[ _i ];
				if( fn == undefined ) return false;
				if ( fn.apply( __this,  arguments ) === false) {
					return false;
				}
			}
		}
		return {
			listen: listen,
			one: one,
			remove: remove,
			trigger: trigger
		}
	})();
	$.fn.cusbind = function() {
		$(this).bind.apply($(this), arguments);
		return $(this);
	};
	$.fn.send = function( type, data ) {
		$(this).trigger(type, data);
		return $(this);
	};
	$.fn.uncusbind = function( type, inst ) {
		$(this).unbind(type);
		return $(this);
	};
	/**
	 * Comm -> exceptionFunc
	 * 异常处理函数
	 * @param type: 提示的message
	 */
	// listLoading获取数据  目前只支持单个列表展示
	// 请求的url ，render需要渲染到指定元素，tpl模板（juicer） 默认加载cb回调
    var publishDownIndex = 0;
	var getDateFn = function(str, is){
		var type = listLoadingObj.type
			, objData = listLoadingObj.data
			, exceptionFunc = Comm.exceptionFunc
			, url = listLoadingObj.url
			, msgOther = CODEMAP.tips.other
			, publishEvents = Comm.publishEvents
			, $http = ZSYWEB.Services
			, detailCallBack = listLoadingObj.detailCallBack
			, adpter = listLoadingObj.adpter
            , Cache = listLoadingObj.Cache
            , render = listLoadingObj.render
            , publishUpCb = listLoadingObj.publishUpCb
            , cb = listLoadingObj.cb
            , publishCb = listLoadingObj.publishCb
            ;

		// 详情页面刷新
		if($.isFunction(detailCallBack)){
			var o = {
				url: url,
	            data: objData,
	            success: function(data){
	                var code = data.code
	                    , message = data.message || msgOther
	                    ;
	                if( code === CODEMAP.status.success) {
	                	detailCallBack(data, function(){
	                		publishEvents.trigger(str);
	                	});
	                }else{
	                    exceptionFunc( message, code );
	                }
	            },
	            error: function(){
	                exceptionFunc( msgOther );
	            }
			}
			if(type === 'post'){
	        	$http.post(o, true);
	        }else{
	        	$http.get(o, true);
	        }
			return;
		}
		// 列表页面刷新
		if(str === 'pullUp'){
			if(lastData) page++;
		}else{
			page = 1;
		}
		var size = objData.defaultPageSize || 20;
		var obj = {
            page: page,
            size: size
        }
        if(objData){
			if(typeof objData.page === 'string'){
				obj[objData.page] = page;
				delete obj.page;
			}
			if(typeof objData.size === 'string'){
				obj[objData.size] = size;
				delete obj.size;
			}
        }
		var data = $.extend(true, {}, obj, objData);
		if(typeof data.page === 'string'){
			delete data.page;
		}
		if(typeof data.size === 'string'){
			delete data.size;
		}
		var o = {
            url: url,
            data: data,
            Cache: str === 'defaultLoader' ? Cache : false,   // 缓存第一屏
            success: function(data){
                // console.log(str)
                // 第一次加载显示下拉加载更多
                publishDownIndex++;
                // 格式化数据
            	if($.isFunction(adpter)){
            		data = adpter(data);
            	}
                var list = data.list
                    , len = list.length
                    , code = data.code
                    , message = data.message || msgOther
                    ;
                lastData = true;
                // 判断请求到的数据与缓存的数据是否一致
                if (code === CODEMAP.status.cacheCode) {
                    publishEvents.trigger(str);
                } else if( code === CODEMAP.status.success && list != undefined) {
                	$('.csn-m-scroll').removeClass('listNone');
                	
                    // 创建模板
                    var html = juicer(listLoadingObj.tpl, data);
                    // 上拉刷新
                    if(str === 'pullUp'){
                        var obj = {};
                        if(len === 0){
                        	lastData = false;
                            obj = {end: true};
                        }else{                            
                            render.append(html);
                        }
                        publishEvents.trigger(str, obj);
                        // 每次下拉回调
                        if($.isFunction(publishUpCb)){
                            publishUpCb(list);
                        }
                    }else{
                        
                    	if(len === 0){
                            $('.csn-m-scroll').addClass('listNone');
                            if($.isFunction(cb)){
	                    		html = cb();
	                    	}else{
	                    		html = '';
	                    	}
                        }
                        render.html(html);
                        publishEvents.trigger(str);
                        // 每次下拉回调
                        if($.isFunction(publishCb)){
                            publishCb(list);
                        }
                    }
                    
                }else{
                    exceptionFunc( message, code );
                }
            },
            error: function(){
                exceptionFunc( msgOther );
            }
        }
        if(type === 'post'){
        	$http.post(o, true);
        }else{
        	$http.get(o, true);
        }
		
	}
	var Comm = {
		initEvent : function() {
			$evt.bind($("body"), ".go-back", "click", function(){
				var flg = true;
				// 产品认购确认书不刷新
				if( $('.header h1').html() == '产品认购确认书'){
					flg = false;
				}
				$core.back(flg);
			});
			$evt.bind($("body"), ".back", "click", function(){
				$core.pop();
			});
		},
		publishEvents : publishEvents,
		// 获取用户信息（检查用户是否登录）
		getLoginToken : function (page) {
			var token = localStorage.getItem('token');
			if (!token && page != 'Index') {
				$core.nextPage('Index');
			} else {
				return token;
			}
			
		},
		// 获取用户信息（检查用户是否登录）
		// $http: $http对象
		// gotologin： 如果未登录是否跳转到登录页面
		// callback: 如果已登录，执行回调，返回用户信息
		// loginJump：登录后跳转信息，格式为 {from:'',to:'',params:''}
		// userinfo($http, true, function(err, data){
		// 	if(data){
		// 	}
		// });
		userinfo: function($http, gotologin, callback, loginJump){
			//
			$http.post({
				url : "info",
				success : function( json ) {
				  var data = json.data || null;
				  var err = '';
				  // 如果未登录，返回null
				  if(json.code == CODEMAP.status.login){
				  	// 跳转
				    if(gotologin !== false){
				    	$nativeapi.gotoLogin(loginJump);
				    	return;
				    }else{
				    	err = json.message || '请登录';
				    	data = null;
				    };
				  }else if(json.code !== CODEMAP.status.success){
				      err = json.message || '未知错误';
				      data = null;
				    }else if(data){
				  	err = '';
				  };
				  // 返回用户信息
				  if(typeof callback === 'function'){
				      callback(err, data, json);
				  };
				}
			}, true);
		},
        // 检查用户是否登录
        getLogin : function (cb, disJump) {

            ZSYWEB.Services.post({
                url: 'info',
                success: function(data){
                    if(data && data.code == CODEMAP.status.success) {
                        if ($.isFunction(cb)) cb(data.data);
                    }else{
                        // 为空则没有登录
                        if ($.isFunction(cb)) cb();
                        // false为不跳转
                        if (!disJump) $core.nextPage('Login');
                    }
                },
                error: function(){
                    // Comm.exceptionFunc( CODEMAP.tips.other );
                }
            }, true);      
        },
        // 支付之后调用 0成功 1失败
        statisticsChannel: function (obj, cb) {
            var o = {
                platform: 'H5',
                status: obj.status == 0 ? '0' : '1',
                type: obj.type || '',
                productId: obj.productId || ''
            };
            Hybrid.tools.getItem("customerId", function (id) {
                o.customerId = id;
                ZSYWEB.Services.post({
                    url: 'statisticsChannel',
                    data: o,
                    success: function(data){
                        if ($.isFunction(cb)) cb();
                    },
                    error: function(){
                        if ($.isFunction(cb)) cb();
                    }
                }, true);
            });
        },
        // 注册或者登录记录
        msgRegister: function (obj, cb) {
            // @"username":useName,
            // @"customerId":useid, 
            // @"platform":DEVICE_SYSTEM, 
            // @"app_id":K_CSN_API_REQUEST_KEY,
            // @"flag":[NSNumber numberWithBool:flag]
            // flag 1注册 0 登录
            var o = {
                flag: obj.flag,
                platform: 'H5',
                customerId: obj.customerId,
                username: obj.username,
                app_id: 'ZSY-CF-APP'
            }
            ZSYWEB.Services.post({
                url: 'msgRegister',
                data: o,
                success: function(data){
                    if ($.isFunction(cb)) cb();
                },
                error: function(){
                    if ($.isFunction(cb)) cb();
                }
            }, true);
        },
        // 退出
        exitlogin: function (cb) {
			// localStorage.removeItem('_ihome_token_');
			// localStorage.removeItem('deviceToken');
			// // 显示金额
			// localStorage.removeItem('_eye_');
			// if( $core.getEnv().runev == 'MOBILE' ) {
			// 	$core.pop();
			// }else{
			// 	$core.nextPage('Index');
			// }
            ZSYWEB.Services.get({
                url: 'Logout',
                success: function(data){
                    sessionStorage.removeItem('_ihome_token_');
                    localStorage.removeItem('deviceToken');
                    // 显示金额
                    localStorage.removeItem('_eye_');
					if( $core.getEnv().runev == 'MOBILE' ) {
						$core.pop();
					}else{
						$core.nextPage('Index');
					}
                },
                error: function(){
                    sessionStorage.removeItem('_ihome_token_');
                    localStorage.removeItem('deviceToken');
                    // 显示金额
                    localStorage.removeItem('_eye_');
                    if( $core.getEnv().runev == 'MOBILE' ) {
						$core.nextPage('Nativeindex');
					}else{
						$core.nextPage('Index');
					}
                }
            }, true);           
        },
		// 图片按比例缩放
		imgResize: function(img, maxh, maxw) {
			var ratio = maxh/maxw;
			if (img.height/img.width > ratio){
				// height is the problem
				if (img.height > maxh){
					img.width = Math.round(img.width*(maxh/img.height));
					img.height = maxh;
				}
			} else {
				// width is the problem
				if (img.width > maxh){
					img.height = Math.round(img.height*(maxw/img.width));
					img.width = maxw;
				}
			}
		},
	    // 设置title显示
	    setTitleVal: function(val){
	    	var title = '__' + $('title').html();
	    	$('title').html(val + title);
	    },
        // 设置headtitle显示
        setHeadTitleVal: function(val){
            document.title = val;
        },
	    listLoading: function(obj){
	    	var listLoading = ZSYWEB.Widget.Refresh;
	    	listLoadingObj = obj;
	    	var o = {
	            id : '#' + (listLoadingObj.id || 'csn-m-main-article'),   // id iscroll
	            // 第一次加载数据
	            defaultLoader : function(){
	                // 获取数据
	                getDateFn('defaultLoader');
	            },
	            // 下拉刷新
	            pullDownAction : function(){
	                // 获取数据
	                getDateFn('pullDown');
	            },
                getIscroll:  function (is) {
                    $('.pullDownLabel.inlineblock-span').html('<i class="icon-loading"></i>正在加载...');
                    $('body').addClass('disScroll');
                    is.scrollTo(0, 0, 2000);
                    // 禁止拖动
                    setTimeout(function () {
                        $('body').removeClass('disScroll');
                    }, 2000);
                }
	        }
        	// 是否禁止上拉刷新
	        if(!$.isFunction(listLoadingObj.detailCallBack) && !listLoadingObj.disableUp){
	        	// 上拉刷新
	        	o.pullUpAction = function(){
	                // 获取数据
	                getDateFn('pullUp');
	            }
	        }
	    	listLoading.setOption(o);
	    },
        exceptionFunc : function ( msg, code) {
            if (typeof msg != 'string') {
                msg = CODEMAP.tips.other;
            }
            if (code == CODEMAP.status.login) {
                ZSYWEB.Core.nextPage('Login');
            } else {
                dialog({"title": msg, arr:[{txt:"确定", cls: "cancel"}]});
            }
        },
        // 金额类添加道号 s字符串或者数字 n保留几位小数
        fmoney: function (s, n) {
            if (!n) n = 2;
            s = s.toString();
            s = parseFloat(s.replace(/[^\d\.-]/g, ""));
            s = s.toString();
            n = n > 0 && n <= 20 ? n : 2;  
            s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";  
            var l = s.split(".")[0].split("").reverse(), r = s.split(".")[1];  
            t = "";  
            for (i = 0; i < l.length; i++) {  
                t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");  
            }  
            return t.split("").reverse().join("") + "." + r;  
        }  
	};
	// 底部导航点击
	var navClick = function () {
		$evt.bind($('#csn-m-index-nav'), 'a', 'click', function(dom) {
			var key = dom.attr('key');
			// 当前页面点击不会load页面
			if (dom.hasClass('active')) return;
            // 首页
            if (key === 'Index') {
                $core.nextPage('Index');
            } 
            // 投资
            else if (key === 'Investment') {
                $core.nextPage('Investment');
            } 
            // 我的财富
            else if (key === 'Me') {
                $core.nextPage('Me');
            }
            // dom.append('<span class="animated-a"></span>');
            // dom.toggleClass('active');
            // dom.find('.animated-a').addClass('active');
            // setTimeout(function () {
            //     $('.animated-a').remove();
            //     dom.addClass('animated');
            //     setTimeout(function () {
            //         // 首页
            //         if (key === 'Index') {
            //             $core.nextPage('Index');
            //         } 
            //         // 投资
            //         else if (key === 'Investment') {
            //             $core.nextPage('Investment');
            //         } 
            //         // 我的财富
            //         else if (key === 'Me') {
            //             $core.nextPage('Me');
            //         }
            //     }, 380);
            // }, 151);
		});
	}
	navClick();

    // 除了index.html investment.html me.html 之外显示 返回投资列表快捷按钮
    var showBackInvestmentBtn = function () {
        if ($('#backInvestmentBtn').length === 0 && location.href.indexOf('appid') > 0) {

            var i = 0, n = -1,
                arr = ['index.html', 'investment.html', 'me.html'], 
                len = arr.length;

            for (; i < len; i++) {
                if (n === -1) {
                    n = location.href.indexOf(arr[i]);
                }
            }
            
            if (n === -1) {
                $('body').append('<a href="javascript:void(0);" id="backInvestmentBtn" class="animated">更多产品</div>');
            }
            
            $('#backInvestmentBtn').addClass('zoomInDown');
        }
        $evt.bind($('#backInvestmentBtn'), '', 'click', function(dom) {
            dom.addClass('active');
            $core.nextPage('Investment');
            
            // setTimeout(function () {
            //     $core.nextPage('Investment');
            // }, 250);
        });
    }
    showBackInvestmentBtn();
	NameSpace.Register("ZSYWEB.Comm", Comm);
	return Comm;
});
