'use strict';

$.fn.attrs = function(attrs) {
    var t = $(this);
    if (attrs) {
        // Set attributes
        t.each(function(i, e) {
            var j = $(e);
            for (var attr in attrs) {
                j.attr(attr, attrs[attr]);
            };
        });
        return t;
    } else {
        // Get attributes
        var a = {},
            r = t.get(0);
        if (r) {
            r = r.attributes;
            for (var i in r) {
                var p = r[i];
                if (typeof p.nodeValue !== 'undefined') a[p.nodeName] = p.nodeValue;
            }
        }
        return a;
    }
};
var NameSpace = {
	Register : function(name, cls) {
		var arg = name;
		var arr = arg.split('.');
		var context = window;
		for( var i = 0; i < arr.length; i++ ) {
			var str = arr[i];
			if( !context[str] ) {
				context[str] = {};
			}
			if( i == (arr.length-1) && cls != undefined ) {
				if( $.isFunction(cls) ) {
					context[str] = cls;
				}else{
					if( context[str] != undefined ) {
						context[str] = $.extend(true, {}, context[str], cls);
					}else{
						context[str] = cls;
					}
				}
			}else{
				context = context[str];
			}
		}
	}
};
(function(){
	var Map = function() {
	    this.elements = new Array();

	    //获取MAP元素个数
	    this.size = function() {
	        return this.elements.length;
	    };

	    //判断MAP是否为空
	    this.isEmpty = function() {
	        return (this.elements.length < 1);
	    };

	    //删除MAP所有元素
	    this.clear = function() {
	        this.elements = new Array();
	    };

	    //向MAP中增加元素（key, value) 
	    this.put = function(_key, _value) {
	    	var v = this.get(_key);
	    	if( v == undefined ){
	    		 this.elements.push( {
	                 key : _key,
	                 value : _value
	             });
	    	}else{
	    		this.set(_key, _value);
	    	}
	       
	    };
	    this.set = function( _key, _value ) {
	    	for ( var i = 0; i < this.elements.length; i++) {
	            if (this.elements[i].key == _key) {
	            	this.elements[i].value = _value;
	                break;
	            }
	        }
	    };
	    //删除指定KEY的元素，成功返回True，失败返回False
	    this.removeByKey = function(_key) {
	        var bln = false;
	        try {
	            for (var i = 0; i < this.elements.length; i++) {
	                if (this.elements[i].key == _key) {
	                    this.elements.splice(i, 1);
	                    return true;
	                }
	            }
	        } catch (e) {
	            bln = false;
	        }
	        return bln;
	    };
	    
	    //删除指定VALUE的元素，成功返回True，失败返回False
	    this.removeByValue = function(_value) {//removeByValueAndKey
	        var bln = false;
	        try {
	            for (var i = 0; i < this.elements.length; i++) {
	                if (this.elements[i].value == _value) {
	                    this.elements.splice(i, 1);
	                    return true;
	                }
	            }
	        } catch (e) {
	            bln = false;
	        }
	        return bln;
	    };
	    
	    //删除指定VALUE的元素，成功返回True，失败返回False
	    this.removeByValueAndKey = function(_key,_value) {
	        var bln = false;
	        try {
	            for (var i = 0; i < this.elements.length; i++) {
	                if (this.elements[i].value == _value && this.elements[i].key == _key) {
	                    this.elements.splice(i, 1);
	                    return true;
	                }
	            }
	        } catch (e) {
	            bln = false;
	        }
	        return bln;
	    };

	    //获取指定KEY的元素值VALUE，失败返回NULL
	    this.get = function(_key) {
	        try {
	            for (var i = 0; i < this.elements.length; i++) {
	                if (this.elements[i].key == _key) {
	                    return this.elements[i].value;
	                }
	            }
	        } catch (e) {
	            return undefined;
	        }
	        return undefined;
	    };

	    //获取指定索引的元素（使用element.key，element.value获取KEY和VALUE），失败返回NULL
	    this.element = function(_index) {
	        if (_index < 0 || _index >= this.elements.length) {
	            return null;
	        }
	        return this.elements[_index];
	    };

	    //判断MAP中是否含有指定KEY的元素
	    this.containsKey = function(_key) {
	        var bln = false;
	        try {
	            for (var i = 0; i < this.elements.length; i++) {
	                if (this.elements[i].key == _key) {
	                    bln = true;
	                }
	            }
	        } catch (e) {
	            bln = false;
	        }
	        return bln;
	    };

	    //判断MAP中是否含有指定VALUE的元素
	    this.containsValue = function(_value) {
	        var bln = false;
	        try {
	            for (var i = 0; i < this.elements.length; i++) {
	                if (this.elements[i].value == _value) {
	                    bln = true;
	                }
	            }
	        } catch (e) {
	            bln = false;
	        }
	        return bln;
	    };
	    
	    //判断MAP中是否含有指定VALUE的元素
	    this.containsObj = function(_key,_value) {
	        var bln = false;
	        try {
	            for (var i = 0; i < this.elements.length; i++) {
	                if (this.elements[i].value == _value && this.elements[i].key == _key) {
	                    bln = true;
	                }
	            }
	        } catch (e) {
	            bln = false;
	        }
	        return bln;
	    };

	    //获取MAP中所有VALUE的数组（ARRAY）
	    this.values = function() {
	        var arr = new Array();
	        for (var i = 0; i < this.elements.length; i++) {
	            arr.push(this.elements[i].value);
	        }
	        return arr;
	    };
	    
	    //获取MAP中所有VALUE的数组（ARRAY）
	    this.valuesByKey = function(_key) {
	        var arr = new Array();
	        for (var i = 0; i < this.elements.length; i++) {
	            if (this.elements[i].key == _key) {
	                arr.push(this.elements[i].value);
	            }
	        }
	        return arr;
	    };

	    //获取MAP中所有KEY的数组（ARRAY）
	    this.keys = function() {
	        var arr = new Array();
	        for (var i = 0; i < this.elements.length; i++) {
	            arr.push(this.elements[i].key);
	        }
	        return arr;
	    };
	    
	    //获取key通过value
	    this.keysByValue = function(_value) {
	        var arr = new Array();
	        for (var i = 0; i < this.elements.length; i++) {
	            if(_value == this.elements[i].value){
	                arr.push(this.elements[i].key);
	            }
	        }
	        return arr;
	    };
	    
	    //获取MAP中所有KEY的数组（ARRAY）
	    this.keysRemoveDuplicate = function() {
	        var arr = new Array();
	        for (var i = 0; i < this.elements.length; i++) {
	            var flag = true;
	            for(var j=0;j<arr.length;j++){
	                if(arr[j] == this.elements[i].key){
	                    flag = false;
	                    break;
	                } 
	            }
	            if(flag){
	                arr.push(this.elements[i].key);
	            }
	        }
	        return arr;
	    };
	};
	var ev = null
		, sev = null
		, configObj = null
		, time = Date.parse(new Date())
		, pageId = time
		, plugsMap = new Map()
		, cusPlugMap = new Map()
		, cusPlugTypeMap = new Map()
		, componentMap = new Map()
		, customerAttr = ["csn-value", "csn-class", "csn-text", "csn-id", "csn-placeholder", "csn-disabled", "csn-maxlength", "csn-error", "csn-onclick"]
		;
	window[time] = {};
	var $scope = window[time];
	var config = function( obj ) {
		require(obj);
	};
	var initPage = function( cb ) {
		var includes = $("include");
		var len = includes.length;
		var index = 0;
		var __loadTemp = function() {
			var pInclude = $(includes[index]).parent();
			var src = $(includes[index]).attr("src");
			if( index < len ) {
				$.ajax({
					url : src,
					dataType : 'html',
					success : function( txt ) {
						$(includes[index]).replaceWith(txt);
						index++;
						__loadTemp();
					},
					error : function() {
						index++;
						__loadTemp();
					}
				});
			}else{
				initComponent(cb);
			}
		};
		__loadTemp();
	};
	var ready = function( cb ) {
		if( !$.isFunction( cb ) ) {
			return;
		}
		if( configObj.env.runev == 'PC' ) {
			$(function(){
				initPage(cb)
			});
		}else if( configObj.env.runev == 'WEIXIN' ) {
			if( window.wx ) {
				Hybrid.WX.getAccessToken(function(){
					Hybrid.WX.shareConfig(function( data ){
						if( data.code == 0 ) {
							var obj = $.extend(true, {}, configObj.wxConfig, data.data);
							wx.config(obj);
						}
					});
				});
				wx.ready(function(){
					Hybrid.WX.share();
					initPage(cb);
				});
			}else{
				initPage(cb);
			}
		}else{
			initPage(cb);
			// Hybrid.registerHandler('Ready', function(data , responseCallback){
				
			// });
		}
	};
	var requestParaMap = function() {
		var id = location.search;
		if (id == "" || id == null || typeof id == "undefined") {
			id = "";
		}
		var arrayObj = id.match(/([^?=&]+)(=([^&]*))?/g);
		var returnMap = {};
		if (arrayObj == null) return returnMap;
		for (var i = 0; i < arrayObj.length; i++) {
			var conment = arrayObj[i];
			var key = decodeURIComponent(conment.substring(0, conment.indexOf("=")));
			var value = decodeURIComponent(conment.substring(conment.indexOf("=") + 1, conment.length));
			returnMap[key] = value;
		};
		if(id == "undefined") {
			return null;
		}else{
			return returnMap;
		}
	};
	var createComponent = function( obj ) {
		var type = obj.type;
		var doms = $(type);
		var attr = obj.attr;
		if( $.isArray(attr) ) {
			for( var i = 0; i < attr.length; i++ ) {
				var t = attr[i];
				if( $.inArray(t, customerAttr ) == -1 ) {
					customerAttr.push(t);
				}
			}
		}
		componentMap.put(type, {
			doms : doms,
			op : obj
		});
	};
	var resolveCustomerAttr = function( dom, htm ) {
		var obj = {};
		for( var i = 0; i < customerAttr.length; i++ ) {
			var attrKey = customerAttr[i];
			var attr = $(dom).attr(attrKey);
			if( attr != undefined ) {
				obj[attrKey] = attr;
				var temp = new RegExp("\\{{" + attrKey + "}}", "g");
				console.info(temp);
				htm = htm.replace(temp, attr);
			}
		}
		return {
			o : obj,
			h : htm
		};
	};
	var initComponent = function( cb ) {
		var keys = componentMap.keys();
		var len = keys.length;
		var index = 0;
		var __getTemplate = function( op, _cb ) {
			var template = null;
			if( op.template != null ) {
				template = op.template;
				_cb(template);
			}else{
				$.ajax({
					url : op.templateUrl,
					dataType : 'html',
					success : function( txt ) {
						_cb( txt );
					},
					error : function() {
						_cb()
					}
				});
			}
		};
		var __loadComponent = function() {
			if( index < len ) {
				var key = keys[index];
				var dom = componentMap.get(key).doms;
				var op = componentMap.get(key).op;
				__getTemplate(op, function( txt ){
					for( var i = 0; i < dom.length; i++ ) {
						var obj = resolveCustomerAttr(dom[i], txt);
						$(dom[i]).html(obj.h);
						op.render($(dom[i]), obj);
					}
					index++;
					__loadComponent();
				});
			}else{
				cb();
			}
		};
		__loadComponent();
	};
	//创建组件的方法
	var createPlug = function( obj ) {
		var util = ZSYWEB.Util;
		var Klass = ZSYWEB.Klass;
		var BasicPlug = ZSYWEB.BasicPlug;
		var type = obj.type;
		var doms = $(type);
		if(!cusPlugTypeMap[type]) {
			cusPlugTypeMap[type] = {};
		}
		for( var i = 0; i < doms.length; i++ ) {
			var p = Klass.extendClass(BasicPlug, obj);
			var e = new p();
			var dom = $(doms[i]);
			var plugId = dom.attr("plugId");
			if( plugId == undefined ) {
				plugId = util.createId();
				dom.attr("plugid",plugId);
			}
			if( !cusPlugMap[plugId] ) {
				cusPlugMap[plugId] = e;
			}
			cusPlugTypeMap[type][plugId] = e;
			var attrs = dom.attrs();
			attrs.plugType = type;
			e.init(attrs, dom);
			e.renderDom();
			// e.render(dom, attrs);
		}
	};
	var Core = {
		$pointer : pageId,
		Ready : function( cb ) {
			ready(cb);
		},
		config : function( obj ) {
			configObj = obj;
			config(obj.loadconfig);	
		},
		getRouteConfig : function() {
			return configObj.route;
		},
		getService : function() {
			return configObj.services;
		},
		getEnv : function() {
			return configObj.env;
		},
		setApiConfig : function( obj ) {
			if( obj ) {
				var apiConfig = configObj.apiConfig;
				configObj.apiConfig = $.extend(true, {}, apiConfig, obj);
			}
		},
		getApiConfig : function() {
			return configObj.apiConfig;
		},
		getAPIVersion : function() {
			return configObj.apiversion;
		},
		getAllConfig : function() {
			return configObj;
		},
		getAppFlg : function() {
			if( configObj.env.runev == 'MOBILE') {
				return true;
			}else{
				return false;
			}
		},
		getHeaders : function() {
			return configObj.headers;
		},
		getPointer : function() {
			return pageId;
		},
		getPlug : function( cid ) {
			return plugsMap.get(cid);
		},
		getCusPlug : function( id ) {
			return cusPlugMap[id];
		},
		getCusPlugs : function( type ) {
			return cusPlugTypeMap[type];
		},
		updateCSNPlug : function( type, id, value ) {
			var target = $(type).find("#"+id);
			var csnPlug = componentMap.get(type);
			if( $.isFunction(csnPlug.op.updatePlug) ) {
				csnPlug.op.updatePlug(target, value);
			}
			console.info(target);
		},
		nextPage : function( str, param ) {
			Hybrid.view.openUrl(str, param, function(){});
		},
		getParam : function() {
			var param = requestParaMap();
			return param;
		},
		installPlugs : function( op ) {
			if( op == undefined ) {
				return;
			}
			var pub = ZSYWEB.Pub;
			for( var key in op ) {
				var _op = op[key];
				var plug = null;
				if( ZSYWEB.Widget[key] != undefined ) {
					plug = new ZSYWEB.Widget[key]();
					plug.$pointer = pageId;
					var cid = _op.cid;
					plug.cid = cid;
					if( plug.init != undefined ) {
						plug.init(_op);
					}else{
						plug.setOption(_op);
					}
					if( plug.install ) {
						plug.install(pub);
					}
					plugsMap.put(cid, plug);
				}
			}
		},
		createPlug : function( obj ) {
			// createComponent(obj);
			createPlug(obj);
		},
		createScroll : function( id, height ) {
			if( height == undefined ) {
				height = $(window).height() - 50;
			}
			$(id).height(height);
			var is = new IScroll(id);
			return is;
		},
		back : function(flg) {
			Hybrid.view.pop(flg);
		},
		backTo : function(key, param) {
			Hybrid.view.backTo(key, param);
		},
		pop : function() {
			Hybrid.view.popRoot();
		},
		setDataControl : function( dc ) {
			this.$dc = dc;
		},
		getDataControl : function() {
			return this.$dc;
		}
	};
	NameSpace.Register("ZSYWEB.Core", Core);
	NameSpace.Register("ZSYWEB.Map", Map);
	NameSpace.Register("ZSYWEB.RootScope", $scope);
}());