define('ZSYWEB.Cache', [], function(){
	var $core = ZSYWEB.Core;
	var MemoryCacheMap = {};
	var apiVer = $core.getAPIVersion();
	var LSG = window.localStorage;
	if( LSG == undefined ) {
		LSG = window.sessionStorage;
	}
	var oldVer = LSG.getItem("_appApiVersion_");
	if( oldVer != apiVer ) {
		LSG.removeItem('memory-cache');
		LSG.setItem("_appApiVersion_", apiVer);
		MemoryCacheMap = {};
	}
	var formatObj = function(obj) {
		if( typeof obj === 'string' ) {
			return obj;
		}
		var url = obj.url;
		var data = obj.data;
		var str = '';
		if( url != undefined ) {
			str += url;
		}
		for( var key in data ) {
			str += "&key=" + key + "&value=" + data[key];
		}
		return str;
	};
	var MemoryCache = {
		set : function( obj, data ) {
			var key = formatObj(obj);
			MemoryCacheMap[key] = data;
			var str = JSON.stringify(MemoryCacheMap);
			LSG.setItem('memory-cache', str);
		},
		get : function( obj ) {
			var mc = JSON.parse(LSG.getItem('memory-cache'));
			var key = formatObj(obj);
			if( mc != null ) {
				return  mc[key];
			}else{
				return undefined;
			}
		},
		del : function( obj ) {
			var key = formatObj(obj);
			MemoryCacheMap[key] = undefined;
			var str = JSON.stringify(MemoryCacheMap);
			LSG.setItem('memory-cache', str);
		},
		clear : function() {
			MemoryCacheMap = {};
			LSG.removeItem('memory-cache');
		}
	};
	NameSpace.Register("ZSYWEB.Cache", MemoryCache);
});