define("ZSYWEB.NativeAPI.PC", ["ZSYWEB.Util"], function () {
    var $core = ZSYWEB.Core
        , $comm = null
        , routeConfig = $core.getRouteConfig()
        ;
    var registerHandler = function() {};
    var callHandler = function ( handlerName, data, responseCallback ) {}
    var WebBridge = {
        registerHandler: registerHandler,
        callHandler: callHandler,
        wrapAPI : function() {},
        version : '0.0.1',
        desc : 'JavaScript hybrid framework.',
        ui : {},
        tools : {},
        view : {},
        network : {}
    };
    var parseParam = function( str, param ) {
        var strings = str.split("?");
        var url = strings[0];
        if( param ) {
            url += "?";
            var index = 0;
            for( var key in param ) {
                var value = param[key];
                if(value == undefined ) {
                    value = '';
                }
                if( index > 0 ) {
                    url += "&"+key;
                    url += "=" + value;
                }else{
                    url += key;
                    url += "=" + value;
                }
                index++;
            }   
        }
        return url;
    };
    WebBridge.view.pop = function() {
        window.history.back();
    };
    WebBridge.view.openUrl = function ( key, param ) {
        $comm = ZSYWEB.Comm;
        localStorage.removeItem('_source_url_');
        var nextUrl = '';
        if( routeConfig == undefined || routeConfig[key] == undefined ) {
            if( param == "" || param == undefined ) {
                nextUrl = key;
            }else{
                var ustr = '?';
                var index = 0;
                for( var key in param ) {
                    var value = param[key];
                    if(value == undefined ) {
                        value = '';
                    }
                    if( index > 0 ) {
                        ustr += "&"+key;
                        ustr += "=" + value;
                    }else{
                        ustr += key;
                        ustr += "=" + value;
                    }
                    index++;
                }   
                nextUrl += ustr;
            }
        }else{
            if(param == undefined) {
                param = {
                    random : new Date().getTime()
                }
            }
            var url = routeConfig[key].url;
            nextUrl = parseParam(url, param);
        }
        if( routeConfig[key] != undefined && routeConfig[key].login === true ) {
            $comm.getLogin(function( data ){
                if( data ) {
                    window.location.href = nextUrl;
                }else{
                    window.localStorage.setItem('_source_url_', JSON.stringify({
                        key : key,
                        param : param
                    }));
                    $core.nextPage('Login');
                }
            });
        }else{
            window.location.href = nextUrl;
        }
    };
    WebBridge.network.security = function( obj ) {
        return obj;
    };
    WebBridge.network.fetch = function( obj ) {
        // console.info(obj);
        if( obj.security ) {
            obj.data = WebBridge.network.security(obj.data);
        }
        $.ajax(obj);
    };
    WebBridge.network.getEnv = function( cb ) {
        cb();
    };

    WebBridge.network.getDeviceInfo = function( cb ) {
        var deviceToken = localStorage.getItem('deviceToken');
        if (deviceToken) {
            cb({
                deviceFinger:'',
                deviceToken : deviceToken
            });
            return;
        };
        var env = $core.getEnv();
        var sev = env.sever.toLocaleLowerCase();
        var serve = $core.getService();
        var url = serve[sev+'app'] + 'h5/get/deviceToken';
        $.ajax({
            type: 'post',
            url: url,
            success: function(json) {
                var obj = eval ("(" + json + ")");
                var code = obj.code;
                if(code == CODEMAP.status.success && !json.data){
                    var deviceToken = obj.data.deviceToken || '';
                    localStorage.removeItem('deviceToken');
                    localStorage.setItem('deviceToken', deviceToken);
                    cb({
                        deviceFinger:'',
                        deviceToken : deviceToken
                    });
                }else{
                    cb({
                        deviceFinger:'',
                        deviceToken : ''
                    });
                }
            },
            error: function(json){
                cb({
                    deviceFinger:'',
                    deviceToken : ''
                });
            }
        });
    };
    WebBridge.network.getLogin = function( cb ) {
        ZSYWEB.Services.post({
            url: 'info',
            success: function(data){
                if(data && data.code == 0) {
                    if ($.isFunction(cb)) cb(data.data);
                }else{
                    if ($.isFunction(cb)) cb();
                    if (!disJump) $core.nextPage('Login');
                }
            },
            error: function(){
                
            }
        });    
    };
    WebBridge.ui.showLoading = function(opacity) {
        var style = '';
        if (opacity) {
            style = ' style="background:rgba(242,242,242, '+ opacity +');"';
        }
        $('body').append('<div id="loading"' + style + '></div>');
    };
    WebBridge.ui.hideLoading = function() {
        $('#loading, #loading-body').fadeOut('slow', function () {
            this.remove();
        });
    };
    WebBridge.ui.toast = function(val, time) {
        var popup = ZSYWEB.Widget.Popup;
        if( popup ) {
            popup(val, time);
        }
    };
    WebBridge.tools.callPhone = function(telNo) {
        eval("window.location.href='tel:"+telNo+"'");
    };
    WebBridge.tools.setItem = function(key, value) {
        localStorage.setItem(key, value);
    };
    WebBridge.tools.getItem = function( key, cb ) {
        var value = localStorage.getItem(key);
        cb(value);
    };
    WebBridge.tools.removeItem = function( key ) {
        localStorage.removeItem(key);
    };
    WebBridge.tools.clear = function() {
        localStorage.clear();
    };
    WebBridge.ui.header = function(){};
    var initHybrid = function() {};
    WebBridge.initHybrid = initHybrid;
    return WebBridge;
});
