define("ZSYWEB.NativeAPI.WEIXIN", ["ZSYWEB.Util"], function () {
    var $core = ZSYWEB.Core
        , $comm = null
        , routeConfig = $core.getRouteConfig()
        ;
    var isEmptyObject = function(obj) {
		for (var n in obj) {
			return false;
		}
		return true;
	};
    var registerHandler = function() {};
    var callHandler = function ( handlerName, data, responseCallback ) {}
    var WebBridge = {
        registerHandler: registerHandler,
        callHandler: callHandler,
        wrapAPI : function() {},
        version : '0.0.1',
        desc : 'JavaScript hybrid framework.',
        ui : {},
        tools : {},
        view : {},
        network : {},
        WX : {}
    };
    var parseParam = function( str, param ) {
        var strings = str.split("?");
        var url = strings[0];
        if( param ) {
            url += "?";
            var index = 0;
            for( var key in param ) {
                var value = param[key];
                if(value == undefined ) {
                    value = '';
                }
                if( index > 0 ) {
                    url += "&"+key;
                    url += "=" + value;
                }else{
                    url += key;
                    url += "=" + value;
                }
                index++;
            }   
        }
        return url;
    };
    WebBridge.view.pop = function() {
        window.history.back();
    };
    WebBridge.view.openUrl = function ( key, param ) {
        $comm = ZSYWEB.Comm;
        localStorage.removeItem('_source_url_');
        var nextUrl = '';
        if( routeConfig == undefined || routeConfig[key] == undefined ) {
            if( param == "" || param == undefined ) {
                nextUrl = key;
            }else{
                var ustr = '?';
                var index = 0;
                for( var key in param ) {
                    var value = param[key];
                    if(value == undefined ) {
                        value = '';
                    }
                    if( index > 0 ) {
                        ustr += "&"+key;
                        ustr += "=" + value;
                    }else{
                        ustr += key;
                        ustr += "=" + value;
                    }
                    index++;
                }   
                nextUrl += ustr;
            }
        }else{
            if(param == undefined) {
                param = {
                    random : new Date().getTime()
                }
            }
            var url = routeConfig[key].url;
            nextUrl = parseParam(url, param);
        }
        if( routeConfig[key] != undefined && routeConfig[key].login === true ) {
            $comm.getLogin(function( data ){
                if( data ) {
                    window.location.href = nextUrl;
                }else{
                    window.localStorage.setItem('_source_url_', JSON.stringify({
                        key : key,
                        param : param
                    }));
                    $core.nextPage('Login');
                }
            });
        }else{
            window.location.href = nextUrl;
        }
    };
    WebBridge.network.security = function( obj ) {
        return obj;
    };
    WebBridge.network.fetch = function( obj ) {
        // console.info(obj);
        if( obj.security ) {
            obj.data = WebBridge.network.security(obj.data);
        }
        $.ajax(obj);
    };
    WebBridge.network.getEnv = function( cb ) {
        cb();
    };
    WebBridge.network.getDeviceInfo = function( cb ) {
        var deviceToken = localStorage.getItem('deviceToken');
        if (deviceToken) {
            cb({
                deviceFinger:'',
                deviceToken : deviceToken
            });
            return;
        };
        var env = $core.getEnv();
        var sev = env.sever.toLocaleLowerCase();
        var serve = $core.getService();
        var url = serve[sev+'app'] + 'h5/get/deviceToken';
        $.ajax({
            type: 'post',
            url: url,
            success: function(json) {
                var obj = eval ("(" + json + ")");
                var code = obj.code;
                if(code == CODEMAP.status.success && !json.data){
                    var deviceToken = obj.data.deviceToken || '';
                    localStorage.removeItem('deviceToken');
                    localStorage.setItem('deviceToken', deviceToken);
                    cb({
                        deviceFinger:'',
                        deviceToken : deviceToken
                    });
                }else{
                    cb({
                        deviceFinger:'',
                        deviceToken : ''
                    });
                }
            },
            error: function(json){
                cb({
                    deviceFinger:'',
                    deviceToken : ''
                });
            }
        });
    };
    WebBridge.network.getLogin = function( cb ) {
        ZSYWEB.Services.post({
            url: 'info',
            success: function(data){
                if(data && data.code == 0) {
                    if ($.isFunction(cb)) cb(data.data);
                }else{
                    if ($.isFunction(cb)) cb();
                    if (!disJump) $core.nextPage('Login');
                }
            },
            error: function(){
                
            }
        });
    };
    WebBridge.ui.showLoading = function(opacity) {
        var style = '';
        if (opacity) {
            style = ' style="background:rgba(242,242,242, '+ opacity +');"';
        }
        $('body').append('<div id="loading"' + style + '></div>');
    };
    WebBridge.ui.hideLoading = function() {
        $('#loading, #loading-body').fadeOut('slow', function () {
            this.remove();
        });
    };
    WebBridge.ui.toast = function(val, time) {
        var popup = ZSYWEB.Widget.Popup;
        if( popup ) {
            popup(val, time);
        }
    };
    WebBridge.tools.callPhone = function(telNo) {
        eval("window.location.href='tel:"+telNo+"'");
    };
    WebBridge.tools.setItem = function(key, value) {
        localStorage.setItem(key, value);
    };
    WebBridge.tools.getItem = function( key, cb ) {
        var value = localStorage.getItem(key);
        cb(value);
    };
    WebBridge.tools.removeItem = function( key ) {
        localStorage.removeItem(key);
    };
    WebBridge.tools.clear = function() {
        localStorage.clear();
    };
    WebBridge.ui.header = function(){};
    WebBridge.WX.getAccessToken = function( cb ) {
        var authCode = $core.getParam().code;
        var appid = $core.getParam().appid;
        if( authCode == undefined || authCode == sessionStorage.getItem('_weixinAuthCode_') ) {
            if( $.isFunction(cb) ) {
                cb();
            }
            return;
        }
        sessionStorage.setItem('_appId_', appid);
        var $http = ZSYWEB.Services;
        var $comm = ZSYWEB.Comm;
        // 显示loading 微信授权没有完成 如果点击登录会导致授权问题
        $('body').append('<div id="showTokenLoading"></div>');
        $http.post({
            url : 'public/3rdparty/token',
            data : {
                authCode : authCode,
                appId : appid
            },
            success : function( data ) {
                if( data.code == 0 ) {
                    sessionStorage.setItem('_weixinAuthCode_', authCode);
                    sessionStorage.setItem('_weixinToken_', data.data.token);
                    // localStorage.setItem('_ihome_token_', data.data.token);
                    // if( data.data.customerId != undefined ) {
                    //     // $core.setCustomerId(data.data.customerId);
                    //     // localStorage.setItem('_ihome_token_', data.data.token);
                    //     // $comm.saveCPS();
                    // }else{
                    //     localStorage.removeItem('_ihome_token_');
                    // }
                }else{
                    sessionStorage.removeItem('_ihome_token_');
                }
                if( $.isFunction(cb) ) {
                    cb();
                }
            }
        });
    };
    WebBridge.WX.shareConfig = function( cb ) {
        var url = window.location.href;
        var appid = sessionStorage.getItem('_appId_');
        var $http = ZSYWEB.Services;
        $http.get({
            url : 'wx/jsconfig',
            data : {
                url : url,
                appId : appid
            },
            success : function( data ) {
                // 删除loading 微信授权没有完成 如果点击登录会导致授权问题
                $('#showTokenLoading').remove();
                console.info(data);
                // if( data.code == 0 ) {
                //     sessionStorage.setItem('_appId_', data.data.appId);
                // }
                cb(data);
            }
        },true);
    };
    WebBridge.WX.share = function( obj ) {
        obj = obj || {};
        var url = window.location.href || obj.link;
        var appid = sessionStorage.getItem('_appId_');
        var weixinConfig = $core.getAllConfig().wxConfig;
        if( isEmptyObject($core.getParam()) ) {
            url += '?appid='+appid;
        }else if( $core.getParam().appid == undefined ) {
            url += '&appid='+appid;
        }
        var imgUrl = weixinConfig.sharePic;
        var wxscope = obj.wxscope || 'snsapi_userinfo';
        url = encodeURIComponent(url);
        var weixinUrl = 'https://open.weixin.qq.com/connect/oauth2/authorize?appid='+appid+'&redirect_uri='+url+'&scope='+wxscope+'&response_type=code#wechat_redirect';
        var o = $.extend(true, {}, {
            title: '我用中顺易财富赚钱啦', // 分享标题
            desc: '推荐您使用中顺易财富，中信、顺丰、网易联合出品，本金安全，收益稳健', // 分享描述
            link: weixinUrl, // 分享链接
            imgUrl: imgUrl, // 分享图标
            type: 'link', // 分享类型,music、video或link，不填默认为link
            dataUrl: '', // 如果type是music或video，则要提供数据链接，默认为空
            success: function () {
                // alert(0)
            },
            cancel: function () {
                // alert(1)
            }
        }, obj);
        var timelineObj = $.extend(true, {}, {
            title: '推荐您使用中顺易财富，中信、顺丰、网易联合出品，本金安全，收益稳健', // 分享标题
            link: weixinUrl, // 分享链接
            imgUrl: o.imgUrl, // 分享图标
            type: 'link', // 分享类型,music、video或link，不填默认为link
            success: function () {
                // alert(0)
            },
            cancel: function () {
                // alert(1)
            }
        }, obj);
        wx.onMenuShareTimeline(timelineObj);
        wx.onMenuShareAppMessage(o);
        wx.onMenuShareQQ(o);
        wx.onMenuShareWeibo(o);
        wx.onMenuShareQZone(o);
    };
    // $core.setApiConfig({
    //     //微信注册
    //     "registerByChannel" : {
    //         url : 'app%public/3rdparty/register'
    //     },
    //      // 微信登录
    //     "login" : {
    //         url : "app%public/3rdparty/login"
    //     },
    //     //登出
    //     "logout" : {
    //         url : "app%public/3rdparty/logout"
    //     },
    //     //风控
    //     "login_tms" : {
    //         url : "app%public/3rdparty/login"
    //     }
    // });
    var initHybrid = function() {};
    WebBridge.initHybrid = initHybrid;
    return WebBridge;
});