define("ZSYWEB.Adapter", ['ZSYWEB.Util'], function (){

var Adapter = {};
////////start


// 我的财富的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            console.log(obj.page)
            return {
                planstate: obj.planstate,
                isMobile : "1",
                page : obj.page,
                start: (obj.page - 1) * obj.size,
                limit : obj.size
            }
        },
        result : function(obj) {
            var data = {code: 1};
            var result = obj.result;
            if (obj.success && result) {
                data = {code: 0, data: []};
                for (var i = 0, len = result.length; i < len; i++){
                    var dataF = result[i];
                    data.data.push({
                        "type": 0,
                        "principal": dataF.userMoney,
                        "rate": dataF.interestRate,
                        "profit": dataF.planPaymentsMoney,
                        "payState": 0,
                        "useDblCard": 0,
                        "pid": dataF.planId,
                        "name": dataF.projectName,
                        "prdState": dataF.bidtime,
                        "orderNo": dataF.orderNo
                    });
                }
            }
            return data;
        }
    };
    
    Adapter.assetApter = adpter;

}());
// 我的财富的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            return {
                str: obj.id + ',Financing,' + obj.orderNo,
                // Financing: obj.orderNo,
                isMobile : "1",
                page : obj.page,
                start: (obj.page - 1) * obj.size,
                limit : obj.size
            }
        },
        result : function(obj) {
            var data = {code: 1};
            var result = obj.result;
            var len = result.length;
            var i = 0;
            if (obj.success && result) {
                var totalMoney = 0;
                var totalRepay = 0;
                data = {
                    code: 0, 
                    list: []
                };
                for (; i < len; i++) {
                    var dataF = result[i];
                    var compensationMoney = dataF.compensationMoney;
                    var intentDate = dataF.intentDate;
                    var factDate = dataF.factDate;
                    data.list.push({
                        "amount" : compensationMoney,
                        "time" : intentDate,
                        "status" : factDate ? '已回款' : '未回款'
                    });
                    // 已回款
                    if (factDate) {
                        totalMoney += compensationMoney;
                    } 
                    // 未回款
                    else {
                        totalRepay += compensationMoney;
                    }
                }
                data.totalMoney = totalMoney;
                data.totalRepay = totalRepay;
            }
            return data;
        }
    };
    
    Adapter.backdetailApter = adpter;

}());
// 我的财富的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            return {
                isMobile : "1"
            }
        },
        result : function(obj) {
            var arr = [];
            if (obj.success && obj.data) {
                var data = {code: 1};
                for (var i = 0, len = obj.data.length; i < len; i++){
                    var dataF = obj.data[i];
                    arr.push({
                        "id": dataF.cardId,
                        "src": "../../images/cards/bg" + dataF.bankname.toLowerCase() + ".png",
                        "name": dataF.bankname,
                        "desc": dataF.bankname,
                        'cardNum' : dataF.cardNum,
                        'cardId' : dataF.cardId,
                        'username': dataF.username
                    });
                }
                data = {
                    code: 0,
                    list: arr
                };
            } else {
                data = obj
            }
            return data;
        }
    };
    
    Adapter.banklistAdapter = adpter;

}());
// 我的财富的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            return {
                userid: obj.userid, 
                couType: obj.couType,
                limit : obj.size,
                page : obj.page,
                start: (obj.page - 1) * obj.size,
                isMobile : "1"
            }
        },
        result : function(obj) {
            var data = {code: 1};
            var result = obj.result;
            var arr = [];
            if (obj.success && result) {
                for (var i = 0, len = result.length; i < len; i++ ) {
                    var dataF = result[i];
                    var couponType = dataF.couponType;              // 优惠劵类型  1返现券 2 体验券 3加息券
                    var couponValue = dataF.couponValue;            // 优惠金额
                    var couponStartDate = dataF.couponStartDate;    // 开始日期
                    var couponEndDate = dataF.couponEndDate;        // 结束日期
                    var couponStatus = dataF.couponStatus;          // 状态
                    var couponsDescribe = dataF.couponsDescribe;    // 描述
                    arr.push({
                        "money" : couponValue,
                        "desc" : couponsDescribe,
                        "rate" : "",
                        "type" : couponType,
                        "couponId": dataF.couponId,
                        "timeLimit" : couponStartDate + "至" + couponEndDate,
                        "couponEndDate": dataF.couponEndDate,
                        "timeUnit" : "",
                        "indate" : "",
                        "source" : "618年中活动赠送",
                        "product" : ""
                    });
                }
                data = {
                    code: 0,
                    data: arr
                };
            }
            return data;
        }
    };
    
    Adapter.CardlistAdapter = adpter;

}());
// 我的财富的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            return {
                isMobile : "1",
                appVerCode: "1",
                os: "IOS",
                app_id: "ZSY-CF-APP",
                appAdplace: obj.appAdplace
            }
        },
        result : function(obj) {
            var data = {code: 1};
            if (obj.success) {
                data = {
                    code: 0, 
                    
                };
            }
            return data;
        }
    };
    
    Adapter.focusmapApter = adpter;

}());
//产品列表的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            // console.info(obj);
            return {
                limit : obj.size,
                page : obj.page,
                isMobile : "1"
            }
        },
        result : function(obj) {
            var data = {};
            if( obj && obj.success && obj.result != undefined ) {
                data.code = 0;
                var result = obj.result;
                var arr = [];
                for( var i = 0; i < result.length; i++ ) {
                    var _o = result[i];
                    var timeLeft = Date.parse(new Date(_o.preSaleTimeStr)) - Date.parse(new Date(_o.nowTimeStr));
                    if( timeLeft <= 0 ) {
                        timeLeft = 0;
                    }
                    var type = 2;
                    if(_o.proType == 'B_Dir') {
                        type = 2;
                    }
                    if( _o.novice == 1 ) {
                        type = 1;
                    }
                    var temp = {
                        "status" : _o.state,
                        "type" : type,
                        "id" : _o.bidId,
                        "name" : _o.bidProName,
                        "rate" : _o.interestRate.toFixed(2), 
                        "timelimit" : _o.loanLife, 
                        "timeUnit" : "", 
                        "desc" : "预期年化收益率", 
                        "startTime" : _o.perSaleTimeStr, 
                        "minPrice" : _o.startMoney,
                        "timeLeft": timeLeft,
                        "Explain": _o.Explain,  // 期限单位
                        "acctulData": _o.acctulData,   // 期限
                        "startMoney": _o.startMoney,  // 起购金额
                        "afterMoney": _o.afterMoney,   // 剩余可购金额
                        "interestRate": _o.interestRate,   // 收益率
                        "riseMoney": _o.riseMoney,   // 加价 递增金额
                        "preSaleTimeStr": _o.preSaleTimeStr,  // 预售时间
                        "nowTimeStr": _o.nowTimeStr  // 当前时间
                    };

                    arr.push(temp);
                }
                data.list = arr;
            }else{
                data.code = 1;
                data.message = '获取投资列表失败';
            }
            return data;
        }
    };
    
    Adapter.InvestmentListAdapter = adpter;

}());
//产品详情的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            return {
                limit : obj.size,
                page : obj.page,
                isMobile : "1"
            }
        },
        result : function(obj) {
            var data = {};
            if( obj && obj.success && obj.result != undefined ) {
                data.code = 0;
                var arr = [];
                //
                data.data = arr;
            }else{
                data.code = 1;
                data.message = '获取投资列表失败';
            }
            return data;
        }
    };
    
    Adapter.InvestmentDetailAdapter = adpter;

}());
// 我的财富的适配器
(function(){
    var $util = ZSYWEB.Util;
    var accAdd = $util.accAdd;
    var accSub = $util.accSub;
    var adpter = {
        param : function( obj ) {
            return {
                isMobile : "1"
            }
        },
        result : function(obj) {
            var data = {code: 1};
            if (obj.success) {
                var temp = accAdd(obj.money,obj.money1);
                temp = accAdd(temp,obj.money3);
                temp = accAdd(temp,obj.money4);
                temp = accSub(obj.money5,temp);
                data = {
                    code: 0, 
                    totalAsset: temp,   // 净资产
                    money: obj.money,   // 累计收益
                    money1: obj.money1,   // 冻结资金总额
                    money3: obj.money3,   // 散标投资本金和利息
                    money4: obj.money4,   // 理财计划本金和利息
                    money5: obj.money5,   // 待还借款总额
                    money6: obj.money6,   // 累计投资总额
                    totalProfit: obj.money12,   // 可用余额 
                };
            }
            // "totalAsset" : "100000.01",
            // "totalProfit" : "2355.55",
            // "repayDate" : "2016-8-19",
            // "repayMoney" : "100",
            // "card" : 3
            return data;
        }
    };
    
    Adapter.MeAdapter = adpter;

}());
//产品详情的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            
        },
        result : function(obj) {
            
        }
    };
    
    Adapter.ProAdapter = adpter;

}());
// 我的财富的适配器
(function(){

    var adpter = {
        param : function( obj ) {
            return {
                limit : obj.size,
                page : obj.page,
                isMobile : "1"
            }
        },
        result : function(obj) {
            var data = {code: 1};
            var result = obj.result;
            console.log(result)
            if (obj.success && result) {
                data = {
                    code: 0,
                    list: result
                };
            }
            return data;
        }
    };
    
    Adapter.RecordsAdapter = adpter;

}());


/////end
NameSpace.Register("ZSYWEB.Adapter", Adapter);

return Adapter;

});
