define("ZSYWEB.Services", ["ZSYWEB.NativeAPI", "ZSYWEB.Cache", "ZSYWEB.Util", 'ZSYWEB.Adapter'], function () {
    var core = ZSYWEB.Core
        , util = ZSYWEB.Util
        , apiConfig = core.getApiConfig()
        , ajaxCount = 0
        , time1 = new Date()
        , adapter = ZSYWEB.Adapter
        , appConfigFlg = core.getAppFlg()
        , $memoryCache = ZSYWEB.Cache
        ;
    // 环境配置
    var URLCONFIG = {
        test : {
            h5 : 'https://test-m.zsyjr.com',
            wmpath : 'https://test-csnwmapi.zsyjr.com',
            wm : 'https://test-csnwmapi.zsyjr.com/',
            app : 'https://test-apfront.zsyjr.com/',
            fet : 'https://test-fet.zsyjr.com/',
            shb : 'https://test-shbapi.zsyjr.com/'
        },
        uat : {
            h5 : 'https://lt-m.zsyjr.com',
            wmpath : 'https://uat-csnwmapi.zsyjr.com',
            wm : 'https://uat-csnwmapi.zsyjr.com/',
            app : 'https://uat-apfront.zsyjr.com/',
            fet : 'https://test-fet.zsyjr.com/',
            shb : 'https://uat-shbapi.zsyjr.com/'
        },
        perf : {
            h5 : 'https://perf-m.zsyjr.com',
            wmpath : 'https://perf-csnwmapi.zsyjr.com',
            wm : 'https://perf-csnwmapi.zsyjr.com/',
            app : 'https://perf-apfront.zsyjr.com/',
            fet : 'https://test-fet.zsyjr.com/',
            shb : 'https://perf-shbapi.zsyjr.com/'
        },
        gray : {
            h5 : 'https://gray-m.zsyjr.com',
            wmpath : 'https://gray-csnwmapi.zsyjr.com',
            wm : 'https://gray-csnwmapi.zsyjr.com/',
            app : 'https://yfb-apfront.zsyjr.com/',
            fet : 'https://gray-fet.zsyjr.com/',
            shb : 'https://gray-shbapi.zsyjr.com/'
        },
        pro : {
            h5 : 'https://m.zsyjr.com',
            wmpath : 'https://csnwmapi.zsyjr.com',
            wm : 'https://csnwmapi.zsyjr.com/',
            app : 'https://apfront.zsyjr.com/',
            fet : 'https://fet.zsyjr.com/',
            shb : 'https://shbapi.zsyjr.com/'
        }
    };
    var formatEnv = function( _e ) {
        var obj = core.getAllConfig();
        var hostname = window.location.hostname;
        var e = hostname.split(".")[0];
        var urlConfig = null;
        if( _e === undefined ) {
            _e = obj.env.sever;
        }
        if(e == ''){
            urlConfig=URLCONFIG[_e];
        }else if( e == 'test-m' ) {
            _e = 'test';
            urlConfig=URLCONFIG.test;
        }else if( e == 'lt-m' ) {
            _e = 'uat';
            urlConfig=URLCONFIG.uat;
        }else if( e == 'gray-m' ) {
            _e = 'gray';
            urlConfig=URLCONFIG.gray;
        }else if( e == 'm' ) {
            _e = 'pro';
        }
        if( urlConfig == null ) {
            urlConfig = URLCONFIG[_e];
        }
        obj.env.sever = _e;
        CODEMAP.CTXPATH = urlConfig.h5;
        CODEMAP.XJBXYPATH = urlConfig.wmpath;
        obj.services[_e] = urlConfig.wm;
        obj.services[_e+'app'] = urlConfig.app;
        obj.services[_e+'fet'] = urlConfig.fet;
        obj.services[_e+'shb'] = urlConfig.shb;
    };
    var formatURL = function( url ) {
        var urls = url.split('|');
        var param = null;
        var result = null;
        if( urls.length > 1 ) {
            var temp = urls[1];
            var temps = temp.split('&');
            for( var i = 0; i < temps.length; i++ ) {
                var _t = temps[i];
                var _ts = _t.split(':');
                var _k = _ts[0];
                var _f = _ts[1];
                if( _k == 'param' ) {
                    param = adapter.param[_f];
                }
                if( _k == 'result' ) {
                    result = adapter.result[_f];
                }
                if( _k == 'adapter' ) {
                    var obj = adapter[_f];
                    if( obj ) {
                        if( $.isFunction(obj.param) ) {
                            param = obj.param;
                        }
                        if( $.isFunction(obj.result) ) {
                            result = obj.result;
                        }
                    }
                }
            }
        }
        url = urls[0];
        return {
            u : url,
            p : param,
            r : result
        };
    };
    var getCookie = function(name){ 
        if( sessionStorage.getItem('_ihome_token_') ) {
            return sessionStorage.getItem('_ihome_token_');
        }else{
            return sessionStorage.getItem('_weixinToken_');
        }
    }; 
    var getDeviceTokenInfo = function( cb ) {
        Hybrid.network.getDeviceInfo(cb);
    };
    var delayLoading = function (){
        $('#loading, #loading-body').fadeOut('slow', function () {
            this.remove();
        });
    };
    var ajax = function (obj) {
        var env = core.getEnv();
        var sev = env.sever.toLocaleLowerCase();
        var serve = core.getService();
        if (obj.showLoading && ajaxCount === 0) {
            Hybrid.ui.showLoading();
            time1 = new Date();
        }
        ajaxCount++;
        obj.complete = function () {
            ajaxCount--;
            if (ajaxCount <= 0) {
                delayLoading();
            }
        };
        var url = obj.url;
        var security = false;
        if( url.split("http").length > 1 ) {
            url = obj.url;
        }else if (apiConfig != undefined && apiConfig[url] != undefined) {
            var urlConfig = apiConfig[url];
            var _ajaxUrl = urlConfig.url;
            security = urlConfig.security;
            
            var arr = _ajaxUrl.split("%");
            if (arr.length > 1) {
                var _temp = (sev + arr[0]).toLocaleLowerCase();
                obj.url = serve[_temp] + arr[1];
            } else if(_ajaxUrl.split("http").length > 1){
                obj.url = _ajaxUrl;
            }else {
                var sev = env.sever.toLocaleLowerCase();
                if (serve[sev] == '' && window.location.origin != 'file://') {
                    serve[sev] = window.location.origin + "/";
                }
                obj.url = serve[sev] + _ajaxUrl;
            }
        } else {
            var sev = env.sever.toLocaleLowerCase();
            if (serve[sev] == '') {
                serve[sev] = window.location.origin + "/";
            }
            obj.url = serve[sev] + url;
        }
        var oo = formatURL(obj.url);
        obj.url = oo.u;
        var paramFn = oo.p;
        var resultFn = oo.r;
        if( $.isFunction(paramFn) ) {
            obj.data = paramFn(obj.data);
        }
        obj.security = security;
        if( $.isFunction(resultFn) ) {
            var nobj = $.extend(true, {}, {}, obj);
            if( nobj.Cache === true ) {
                var data = $memoryCache.get(nobj);
                if( data != undefined ) {
                    // var dt = resultFn(data);
                    nobj.success( data );
                }
            }
            obj.success = function( data ){
                delayLoading();
                var dt = resultFn(data);
                if( dt && dt.code == 0 && dt.data.token ) {
                    sessionStorage.setItem('_ihome_token_', dt.data.token);
                }
                var cdata = $memoryCache.get(nobj);
                if( dt && cdata && dt.code == 0 && cdata.code == 0 ) {
                    var dstr = JSON.stringify(dt);
                    var cstr = JSON.stringify(cdata);
                    var dstrMd5 = md5(dstr);
                    var cstrMd5 = md5(cstr);
                    console.info(md5(dstr));
                    console.info(md5(cstr));
                    if( dstrMd5 == cstrMd5 ) {
                        dt.code = 304;
                    }
                }
                if( nobj.Cache === true ) {
                    if( dt.code == 0 ) {
                        $memoryCache.set(nobj, dt);
                    }
                }
                nobj.success( dt );
            };
        }else{
            var nobj = $.extend(true, {}, {}, obj);
            if( nobj.Cache === true ) {
                var data = $memoryCache.get(nobj);
                if( data != undefined ) {
                    nobj.success( data );
                }
            }
            obj.success = function( data ){
                delayLoading();
                if( data && data.code == 0 && data.data && data.data.token ) {
                    sessionStorage.setItem('_ihome_token_', data.data.token);
                }
                var cdata = $memoryCache.get(nobj);
                if( data && cdata && data.code == 0 && cdata.code == 0 ) {
                    var dstr = JSON.stringify(data);
                    var cstr = JSON.stringify(cdata);
                    var dstrMd5 = md5(dstr);
                    var cstrMd5 = md5(cstr);
                    console.info(md5(dstr));
                    console.info(md5(cstr));
                    if( dstrMd5 == cstrMd5 ) {
                        data.code = 304;
                    }
                }
                if( nobj.Cache === true ) {
                    if( data.code == 0 ) {
                        $memoryCache.set(nobj, data);
                    }
                }
                nobj.success( data );
            };
        }
        Hybrid.network.fetch(obj);
    },
    formatHeader = function (obj, type) {
        obj.type = type;
        obj.dataType = 'json';
        var token = getCookie();
        var defaultHeaders = $.extend(true, {}, {
            'ihome-timestamp': util.cTimestamp(),
            'uid': util.cTimestamp() + "-" + util.generateUUID(),
            'ihome-version': core.getAPIVersion(),
            'appversion': core.getAPIVersion(),
            'ihome-token' : token
        }, core.getHeaders());
        var _o = $.extend(true, {}, {headers : defaultHeaders}, obj);
        return _o;
    };
    var $http = {
        get: function (obj, loginFlg) {
            var _o = formatHeader(obj, "GET");
            Hybrid.network.getEnv(function( e ){
                formatEnv(e);
                getDeviceTokenInfo(function( obj ){
                    _o.headers['ihome-deviceFinger'] = obj.deviceFinger;
                    _o.headers['deviceFinger'] = obj.deviceFinger;
                    _o.headers['deviceToken'] = obj.deviceToken;
                    ajax(_o);
                });
            });
        },
        post: function (obj, loginFlg) {
            var _o = formatHeader(obj, "POST");
            Hybrid.network.getEnv(function(e){
                formatEnv(e);
                getDeviceTokenInfo(function( obj ){
                    _o.headers['ihome-deviceFinger'] = obj.deviceFinger;
                    _o.headers['deviceFinger'] = obj.deviceFinger;
                    _o.headers['deviceToken'] = obj.deviceToken;
                    ajax(_o);
                });
            });
        },
        put: function () {
        }
    };
    NameSpace.Register("ZSYWEB.Services", $http);
    return $http;
});
