define("ZSYWEB.Widget.Carousel", ["juicer", "ZSYWEB.Services", "ZSYWEB.Comm"], function() {
    $('<link rel="stylesheet" type="text/css" href="../../widget/carousel/carousel.css" />').appendTo('head');
    var $http = ZSYWEB.Services
        , comm = ZSYWEB.Comm
        , imgResize = comm.imgResize
        , exceptionFunc = comm.exceptionFunc
        , animateFn = null
        ;
    var Carousel = function(obj){

        if(obj === 'clearAnimate'){
            clearInterval(animateFn);
            return;
        }
        var data = obj.data
            , adapter = obj.adapter
            , id = obj.id
            , url = obj.url
            , type = obj.type
            , time = obj.time || 3000
            , winWid = $(window).width()
            , callback = obj.callback
            ;
        if (animateFn) {
            clearInterval(animateFn);
            $(id).html('');
        }
        var setDataFn = function(data){
            if( !data || !$.isArray(data.list) ) {
                if ($.isFunction(callback)){
                    callback();
                }
                return;
            }
            var len = data.list.length
                , index = 0
                ;
            var _tpl = '<ul class="carousel-article-ul" style="width:' + winWid*len + 'px;">\
                {@each list as it}\
                <li style="width:' + winWid + 'px;" {@if it.href}data-href="${it.href}"{@/if} {@if it.attr}${it.attr|setAttr}{@/if}>\
                    <img src="{@if it.src}${it.src}{@else}{@/if}" {@if it.attr && it.attr.title}title="${it.attr.title}" alt="${it.attr.title}"{@/if} />\
                </li>\
                {@/each}\
            </ul>';
            if (len > 1){
                _tpl += '<div class="carousel-icon abs">{@each list as it, index}<span{@if index == 0} class="active"{@/if}>${index}</span>{@/each}</div>';
            }
            // 设置attr
            juicer.register('setAttr', function(attr){
                var _attr = [];
                for(var key in attr){
                    _attr.push(key + '=' + attr[key]);
                }
                _attr = _attr.join(' ');
                return _attr;
            });
            var _html = juicer(_tpl, data);
            $(id).append(_html);

            if ($.isFunction(callback)) {
                callback();
            }
            // 不创建动画
            if (len <= 1) {
                return;
            }
            var _is = new IScroll(id, {
                scrollX: true,
                scrollY: false,
                momentum: false,
                snap: true,
                snapSpeed: 400,
                keyBindings: true
            });
            _is.on('scrollEnd', function(){
                index = this.currentPage.pageX;
                toggleIcon(index);
            });
            var toggleIcon = function(index){
                $('.carousel-icon>span').eq(index).addClass('active').siblings().removeClass('active');
            }
            animateFn = setInterval(function(){
                index++;
                if(index >= len){
                    index = 0;
                }
                _is.currentPage.pageX = index;
                toggleIcon(index);
                var left = -index*winWid;
                _is.scrollTo(left, 0, 300);
            }, time);
        }
        var o = {
            url: url,
            success: function(data){
                var code = data.code
                    , message = data.message || CODEMAP.tips.other
                    , data = data.data
                    ;

                if( code === CODEMAP.status.success) {
                    if($.isFunction(adapter)){
                        data = adapter(data);
                    }
                    setDataFn(data);
                }else{
                    // exceptionFunc( message, code );
                }
            },
            error: function(){
                // exceptionFunc( CODEMAP.tips.other );
            }
        }
        if(typeof data === 'object'){
            o.data = data;
        }
        if(type === 'post'){
            $http.post(o, true);
        }else{
            $http.get(o, true);
        }
    }
    NameSpace.Register("ZSYWEB.Widget.Carousel", Carousel);
    return Carousel;
});