define("ZSYWEB.Widget.ListLoading", ['ZSYWEB.Event', 'ZSYWEB.BasicPlug', 'ZSYWEB.Comm', 'ZSYWEB.Widget.Refresh'], function () {
    var $core = ZSYWEB.Core
        , comm = ZSYWEB.Comm
        ;
    $core.createPlug({
        type : "csn-listloading",
        template : '<article id="{{csn-id}}" class="listLoading-article"><section class="csn-m-scroll"><div id="render-listloading-{{csn-id}}"></div></section></article>',
        render : function( dom, obj ) {
            var state = this.state
                , template = state.template
                , detailCallBack = state.detailCallBack
                ;
            if( state === undefined || (!$.isFunction(detailCallBack) && template === undefined)) {
                return;
            }
            var id = obj['csn-id'];
            if($.isFunction(template) && !$.isFunction(detailCallBack)){
                template = template() || obj['csn-template'] || '';
            }
            comm.listLoading({
                id: id,
                render: $('#render-listloading-' + id),
                url: obj['csn-url'],
                tpl: template,
                adapter: state.adapter,
                type: obj['csn-type'],
                data: state.data,
                detailCallBack: detailCallBack
            });
        }
    });
});
 