define("ZSYWEB.Widget.Pushbutton", ['ZSYWEB.Comm', 'ZSYWEB.Event', 'juicer'], function (){
	var xs = ZSYWEB.Comm
		, evt = ZSYWEB.Event
		, evtControl = ZSYWEB.EventCollector
		;

	var Pushbutton = function(obj){
		if ( obj == undefined ) {
			return;
		}
		var id = obj.id ? obj.id : 'pushbutton'
		  , appendHtmlObj = obj.appendHtml ? obj.appendHtml : $('body')
		  , clickCallback = obj.clickCallback
		  ;
		this.id = id;
		var tpl = '<section id="' + id + '" class="pushbutton ' + (obj.isHide ? 'pushbutton-out dn' : 'pushbutton-in') + '"><div class="bg"></div>\
					<ul class="push-list">\
						{@each data as it}\
							<li class="${it.cls}" data-key="${it.key}">${it.text}</li>\
						{@/each}\
						<li class="pushbutton-cancel">取消</li>\
					</ul>\
				</section>';
		var html = juicer(tpl, obj);
		appendHtmlObj.append(html);

		var evts = {
	        id: "widget-" + id,
	        el: "body",
	        evt: {
	            "click .push-list>li": "clickLi"
	        },
	        handle: {
	            clickLi: function (dom) {
	            	if( $.isFunction( clickCallback ) ){
	            		clickCallback(dom);
	            	}
	            	if( $(dom).hasClass('pushbutton-cancel') ){
	            		Pushbutton.hide(id);
	            	}
	            }
	        }
	    }
	    Pushbutton.show = function ( id ) {
	    	$('#' + id).removeClass('pushbutton-out').show().addClass('pushbutton-in');
	    }
	    Pushbutton.hide = function ( id ) {
	    	$('#' + id).addClass('pushbutton-out');
    		setTimeout(function() {
    			$('#' + id).removeClass('pushbutton-out pushbutton-in').hide();
    		}, 351);
	    }
		// 绑定事件
        evtControl.initEvents(evts);
	}
	NameSpace.Register("ZSYWEB.Widget.Pushbutton", Pushbutton);
	return Pushbutton;
});