define("ZSYWEB.Widget.Refresh", ['ZSYWEB.Comm', 'ZSYWEB.Event', 'ZSYWEB.Filter', 'ZSYWEB.Util'], function (){
	var comm = ZSYWEB.Comm
		, evt = ZSYWEB.Event
		, Filter = ZSYWEB.Filter
		, timeDifference = ZSYWEB.Util.timeDifference
		, publishEvents = comm.publishEvents
		;
	var Refresh = {
		setOption : function(obj) {
			var listLoadingIscroll 
			, pullDownOffset
			, pullUpOffset
			, pullUpEl
			, pullDownEl
			, id = obj.id
			, isTime = obj.isTime  // 是否需要显示时间
			, uploadmoretxt = '<i class="icon-up"></i>上拉加载更多'
			, pullDrefreshtxt = '<i class="icon-down"></i>下拉加载更多'
			, clickloadmoretxt = '<i class="icon-loading"></i>正在加载更多'
			, loadertxt = '<i class="icon-loading"></i>正在加载更多'
			, Realtimetxt = '松开刷新'
			, loaderendtxt = '已显示完全部'
			, uprefreshtxt = '<i class="icon-loading"></i>正在加载更多'
			, loading_gif = '<img src="../../images/loading_gif18.gif" class="loading-gif" width="28" height="28" />'
			, __flg = true   // 防止多次拖拽
			, __idHeight = $(id).height()
			, __endDate = Date.parse(new Date())
			, __children = $($(id).get(0).children[0])
			, IScrollTopAanimated
			, _idReplace = id.replace('#', '')
			, _idReplace = _idReplace.replace('.', '')
			, pullUpId = 'pullUp-' + _idReplace
			, pullDownId = 'pullDown-' + _idReplace
			, clickDownId = 'clickDown-' + _idReplace
			, multiple = obj.multiple  // 一个页面多个listloading
			, multipleId = ''
			, pubtimeStart
			;
			// 扩充一个页面多个listloading
			if (multiple) {
				multipleId = id.split('#')[1];
			}
			publishEvents.remove('defaultLoader' + multipleId);
			publishEvents.remove('pullUp' + multipleId);
			publishEvents.remove('pullDown' + multipleId);
			publishEvents.remove('iscrollChange' + multipleId);
			// 防止拖动点击
			$(id).addClass('rel');
			// 是否显示上拉加载更多
			var __isShowRefreshDow = function(){
				// 如果加载更多存在 则不再去load pullUp
				if(pullUpEl) return;
				// 设置滚动
				var __childrenHeight = $(__children).height()
					, __minScrollHeight = __idHeight + pullDownOffset   // 最小滚动高度
					;
				
				if(!obj.clickDownAction && obj.pullUpAction && __childrenHeight > __minScrollHeight){
					$(__children).append('<div id="' + pullUpId + '" data-class="pullUpId">' + '<span class="pullUpLabel inlineblock-span">' + uploadmoretxt + '</span></div>');
					pullUpEl = $('#' + pullUpId);
					pullUpOffset = pullUpEl.get(0).offsetHeight;
				}else{
					$(__children).css('min-height', __minScrollHeight);
				}
			}
			// iscroll内容改变
			publishEvents.listen('iscrollChange' + multipleId, function(data){
				var __childrenHeight = $(__children).height()
					, __minScrollHeight = __idHeight + pullDownOffset   // 最小滚动高度
					;
				if(__childrenHeight <= __minScrollHeight && pullUpEl){
					pullUpEl.remove();
					pullUpEl = null;
				}
				// 是否显示上拉加载更多
				__isShowRefreshDow();
				listLoadingIscroll.refresh();
			});
			// 默认创建listLoading
			var	__creatIScrollFn = function(){
				var __timeHtml = isTime ? '<span class="time">最后更新时间：<em id="time-em"></em></span>' : ''
					, pullDownHtml = '<div id="' + pullDownId + '" data-class="pullDownId">' +
								     '	<span class="pullDownLabel inlineblock-span">' + pullDrefreshtxt + '</span>' + 
								     	__timeHtml + 
								     '</div>';
				$(pullDownHtml).prependTo($(__children));

				pullDownEl = $('#' + pullDownId);

				pullDownOffset = pullDownEl.get(0) ? pullDownEl.get(0).offsetHeight : 0;

				
				// 是否显示上拉加载更多
				__isShowRefreshDow();
				
				// 点击加载更多
				if( obj.clickDownAction && $.isFunction(obj.clickDownAction) ){
					$(__children).append('<div id="' + clickDownId + '" data-class="clickDownId"><span class="clickDownLabel">' + clickloadmoretxt + '</span></div>');
					evt.bind($("body"), "#" + clickDownId, "click", function(){
						$('.clickDownLabel').html(loadertxt);
						if(__flg){ // 防止多次点击
							publishEvents.listen('clickDown'  + multipleId, function(){
								publishEvents.remove('clickDown' + multipleId);
								listLoadingIscroll.refresh();		// 数据加载完成后，调用界面更新方法
								$('.clickDownLabel').html(clickloadmoretxt);
								__flg = true; // 防止多次点击		
							});
						}
						__flg = false;
						obj.clickDownAction();
					});
				}
			};
			// 设置class和提示
			var __toggleTextFn = function(obj, cls, labelCls, text){
				obj.attr('class', cls).find('.' + labelCls).html(text);
			}
			// 复位动画
			var __animateFn = function(hei){
				listLoadingIscroll.scrollTo(0, hei, 300, IScrollTopAanimated);
			}
			// 创建action
			var __loaderFn = function(){
				var __timeStart = 0
					, __timeEnd = 0
					, __totaltime = 0
					;
				
				// 开始
				listLoadingIscroll.on('scrollStart', function(){
					__timeStart = new Date().getTime();
					pubtimeStart = __timeStart;
					$('#' + pullUpId + ' .loading-gif').removeClass('dn');
					// 时间
					if(isTime && timeDifference) $('#time-em').html(timeDifference(__endDate));

					if( pullDownEl.hasClass('loading') ) {
						// 设置class和提示
						__toggleTextFn(pullDownEl, '', 'pullDownLabel', pullDrefreshtxt);
					} else if( pullUpEl && pullUpEl.hasClass('loading') ) {
						// 设置class和提示
						__toggleTextFn(pullUpEl, '', 'pullUpLabel', uploadmoretxt);
					}
				});
				// 移动
				listLoadingIscroll.on('scrollMove', function(){
					var __y = this.y
						, __number = 5
						, __pullDownElCls = pullDownEl.hasClass('flip')
						, __pullUpElCls = pullUpEl && pullUpEl.hasClass('flip')
						, __maxScrollY = this.maxScrollY
						;
					// 防止拖动点击 添加一个遮罩层
					$(__children).addClass('scroll');   
					
					if ( __y > __number && !__pullDownElCls ) {
						// 设置class和提示
						__toggleTextFn(pullDownEl, 'flip', 'pullDownLabel', '<i class="icon-up"></i>' + Realtimetxt);
					}
					else if (__y < __number && __pullDownElCls) {
						// 设置class和提示
						__toggleTextFn(pullDownEl, '', 'pullDownLabel', pullDrefreshtxt);
					} 
					else if (pullUpEl && __y < (__maxScrollY - __number) && !__pullUpElCls) {
						// 设置class和提示
						__toggleTextFn(pullUpEl, 'flip', 'pullUpLabel', '<i class="icon-down"></i>' + Realtimetxt);
					} 
					else if (pullUpEl && __y > (__maxScrollY + __number) && __pullUpElCls) {
						// 设置class和提示
						__toggleTextFn(pullUpEl, '', 'pullUpLabel', uploadmoretxt);
					}

				});
				// 结束
				listLoadingIscroll.on('scrollEnd', function(){
					// 滚动到底自动加载更多
					if(this.y === this.maxScrollY && pullUpEl){
						__toggleTextFn(pullUpEl, 'flip', 'pullUpLabel', Realtimetxt);
					}
					__timeEnd = new Date().getTime();
					__totaltime = __timeEnd - __timeStart;
					__endDate = Date.parse(new Date());
					// quadratic | circular | back | bounce | elastic
					IScrollTopAanimated = IScroll.utils.ease.quadratic;

					// 删除遮罩层 
					$(__children).removeClass('scroll');
					
					// 防止拖动过快卡屏
					if( __totaltime < 200 ) {
						if(this.y > -pullDownOffset && this.y < 1){
							// 隐藏加载完毕文字
							__animateFn(-pullDownOffset);
						}
						return false;
					}

					if (pullDownEl.hasClass('flip')) {
						// 设置class和提示
						__toggleTextFn(pullDownEl, 'loading', 'pullDownLabel', loadertxt);	
						// 下拉刷新		
						__pullDownAction();
					}
					else if (pullUpEl && pullUpEl.hasClass('flip')) {
						// 设置class和提示
						__toggleTextFn(pullUpEl, 'loading', 'pullUpLabel', loadertxt);
						// 上拉加载更多
						__pullUpAction();
					}
					// 
					else if( this.y > -pullDownOffset && this.y < 1 ){
						// 隐藏加载完毕文字
						__animateFn(-pullDownOffset);
					}
				});
			}
			// 上拉加载更多
			var __pullUpAction = function(){
				// 防止暴力拖拽
				var _time = new Date().getTime()-pubtimeStart;
				if( $.isFunction(obj.pullUpAction) && _time >= 400 ) {
					publishEvents.listen('pullUp' + multipleId, function(data){
						var loaderText = loaderendtxt;
						// 数据全部加载完毕
						if( data.end ){
							pullUpEl.find('.loading-gif').addClass('dn');
							__animateFn(listLoadingIscroll.y + pullUpOffset);
						}else{
							loaderText = uploadmoretxt;
						}
						pullUpEl.find('.pullUpLabel').html(loaderText);
						// 数据加载完成后，调用界面更新方法
						listLoadingIscroll.refresh();
						publishEvents.remove('pullUp' + multipleId);
					});
					obj.pullUpAction();
				}
			}
			// 下拉刷新
			var __pullDownAction = function() {
				// 防止暴力拖拽
				var _time = new Date().getTime()-pubtimeStart;
				if( $.isFunction(obj.pullDownAction) && _time >= 400 ) {
					publishEvents.listen('pullDown' + multipleId, function(){
						if( pullUpEl ) pullUpEl.find('.pullUpLabel').html(uploadmoretxt);
						// 是否显示上拉加载更多
						__isShowRefreshDow();
						__animateFn(-pullDownOffset);
						// 数据加载完成后，调用界面更新方法
						listLoadingIscroll.refresh();
						// 删除
						publishEvents.remove('pullDown' + multipleId);
					});
					obj.pullDownAction();
				}
			}
			// 默认加载
			if( $.isFunction(obj.defaultLoader) ){
				// 默认加载
				publishEvents.listen('defaultLoader' + multipleId,function(){
					// 滚动区域必须要大于它父元素 才会创建listloading  data
					// if( $(__children).height() < __idHeight ) return;

					// 默认创建listLoading
					__creatIScrollFn();  
					// 点击返回顶部top
					// if($('#csn-m-dollar-top').length === 0){
					// 	$('body').append('<div id="csn-m-dollar-top"></div>');
					// }
					// 创建IScroll
					listLoadingIscroll = new IScroll(id,{
						// preventDefault为false这行就是解决onclick失效问题
		                // 为true就是阻止事件冒泡,所以onclick没用
		                // preventDefault: false,
						startY : -pullDownOffset,
						listLoading: true, // iscroll中_move  433行  刷新bug
						// probeType: 3   // 这个属性是调节在scroll事件触发中探针的活跃度或者频率。有效值有：1, 2, 3。数值越高表示更活跃的探测。探针活跃度越高对CPU的影响就越大。  iscroll-probe.js
					});
					// listLoadingIscroll.on('scroll', function(){
				 //        var newY = Math.abs(this.y)
				 //        	, hei = $(window).height() + 300
				 //        	;
				 //        if(newY > hei){
				 //        	$('#csn-m-dollar-top').show();
				 //        }else{
				 //        	$('#csn-m-dollar-top').hide();
				 //        }
				 //    });
				 //    evt.bind($("body"), "#csn-m-dollar-top", "click", function(){
					// 	listLoadingIscroll.scrollTo(0, 0, 300);
					// });
					__loaderFn();
					publishEvents.remove('defaultLoader' + multipleId);
					// 回调iscroll
					if ($.isFunction(obj.getIscroll)) {
						obj.getIscroll(listLoadingIscroll);
					}
				});
				obj.defaultLoader();
			}
		}
	};
	NameSpace.Register("ZSYWEB.Widget.Refresh", Refresh);
	return Refresh;
});